//---------------------------------------------------------------------------
#ifndef http_utils_h
#define http_utils_h
//---------------------------------------------------------------------------
#include <string>
#include <map>
#include <ctime>
//---------------------------------------------------------------------------
#include "platform.h"
//---------------------------------------------------------------------------
int str_length(char *s);
char *find_str(char *beg, char *end, char *s);
//---------------------------------------------------------------------------
//method uri protocol_version
//name: value
//name: value
//
bool parse_header
(
    char *beg, char *end, char **pos,
    std::string * const method,
    char **uri_beg, char **uri_end,
    std::string * const protocol_version,
    std::map<std::string, std::string> * const params
);
//---------------------------------------------------------------------------
//protocol://login:password@host:port/path?query#fragment
bool parse_uri
(
    char *beg, char *end, char **pos,
    std::string * const protocol,
    std::string * const login,
    std::string * const password,
    std::string * const host,
    int * const port,
    std::string * const path,
    char **query_beg, char **query_end,
    std::string * const fragment
);
//---------------------------------------------------------------------------
//protocol://login:password@host_port/path?query#fragment
std::string create_uri
(
    const std::string &protocol,
    const std::string &login,
    const std::string &password,
    const std::string &host_port,
    const std::string &path,
    const std::string &query,
    const std::string &fragment
);
//---------------------------------------------------------------------------
std::string get_content_type(const std::string &ext);
//---------------------------------------------------------------------------
//name=value&name=value
bool parse_query
(
    char *beg, char *end, char **pos,
    std::map<std::string, std::string> * const params
);
//---------------------------------------------------------------------------
std::string http_time_str(const std::time_t t);
std::string get_ext(const std::string &s);
std::string get_name(const std::string &s);
std::string change_ext(const std::string &name, const std::string &ext);
std::string get_path(const std::string &s);
int get_level_min(const std::string &path);
int http_print
(
    char *buffer,
    int * const sizeof_header,
    const char *code_and_reason,
    const char *lines = 0,
    const char *content_type = 0,
    const char *content = 0
);
//---------------------------------------------------------------------------
//name=value
//name=value
//
bool parse_params
(
    char *beg, char *end,
    std::map<std::string, std::string> * const params
);
//---------------------------------------------------------------------------
#endif //http_utils_h
